/**
 * generated by Xtext 2.25.0
 */
package org.xtext.example.methodname.methodName.impl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

import org.eclipse.emf.ecore.impl.EPackageImpl;

import org.xtext.example.methodname.methodName.And;
import org.xtext.example.methodname.methodName.CardinalityModifier;
import org.xtext.example.methodname.methodName.Case;
import org.xtext.example.methodname.methodName.Declaration;
import org.xtext.example.methodname.methodName.Expr;
import org.xtext.example.methodname.methodName.FixedDeclaration;
import org.xtext.example.methodname.methodName.Frequency;
import org.xtext.example.methodname.methodName.GroupExpr;
import org.xtext.example.methodname.methodName.Kind;
import org.xtext.example.methodname.methodName.MethodNameFactory;
import org.xtext.example.methodname.methodName.MethodNamePackage;
import org.xtext.example.methodname.methodName.Model;
import org.xtext.example.methodname.methodName.Or;
import org.xtext.example.methodname.methodName.POSValue;
import org.xtext.example.methodname.methodName.Property;
import org.xtext.example.methodname.methodName.Rule;
import org.xtext.example.methodname.methodName.Sentiment;
import org.xtext.example.methodname.methodName.StringConst;
import org.xtext.example.methodname.methodName.SynonymConst;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class MethodNamePackageImpl extends EPackageImpl implements MethodNamePackage
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass modelEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass declarationEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass fixedDeclarationEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass ruleEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass caseEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass exprEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass groupExprEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass propertyEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass orEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass andEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass stringConstEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass posValueEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass synonymConstEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EEnum kindEEnum = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EEnum sentimentEEnum = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EEnum posEEnum = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EEnum cardinalityModifierEEnum = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EEnum frequencyEEnum = null;

  /**
   * Creates an instance of the model <b>Package</b>, registered with
   * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
   * package URI value.
   * <p>Note: the correct way to create the package is via the static
   * factory method {@link #init init()}, which also performs
   * initialization of the package, or returns the registered package,
   * if one already exists.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.eclipse.emf.ecore.EPackage.Registry
   * @see org.xtext.example.methodname.methodName.MethodNamePackage#eNS_URI
   * @see #init()
   * @generated
   */
  private MethodNamePackageImpl()
  {
    super(eNS_URI, MethodNameFactory.eINSTANCE);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private static boolean isInited = false;

  /**
   * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
   *
   * <p>This method is used to initialize {@link MethodNamePackage#eINSTANCE} when that field is accessed.
   * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #eNS_URI
   * @see #createPackageContents()
   * @see #initializePackageContents()
   * @generated
   */
  public static MethodNamePackage init()
  {
    if (isInited) return (MethodNamePackage)EPackage.Registry.INSTANCE.getEPackage(MethodNamePackage.eNS_URI);

    // Obtain or create and register package
    Object registeredMethodNamePackage = EPackage.Registry.INSTANCE.get(eNS_URI);
    MethodNamePackageImpl theMethodNamePackage = registeredMethodNamePackage instanceof MethodNamePackageImpl ? (MethodNamePackageImpl)registeredMethodNamePackage : new MethodNamePackageImpl();

    isInited = true;

    // Create package meta-data objects
    theMethodNamePackage.createPackageContents();

    // Initialize created meta-data
    theMethodNamePackage.initializePackageContents();

    // Mark meta-data to indicate it can't be changed
    theMethodNamePackage.freeze();

    // Update the registry and return the package
    EPackage.Registry.INSTANCE.put(MethodNamePackage.eNS_URI, theMethodNamePackage);
    return theMethodNamePackage;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EClass getModel()
  {
    return modelEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EReference getModel_Declarations()
  {
    return (EReference)modelEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EReference getModel_FixedDeclarations()
  {
    return (EReference)modelEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EReference getModel_Rules()
  {
    return (EReference)modelEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EReference getModel_Elements()
  {
    return (EReference)modelEClass.getEStructuralFeatures().get(3);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EClass getDeclaration()
  {
    return declarationEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EAttribute getDeclaration_Name()
  {
    return (EAttribute)declarationEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EAttribute getDeclaration_Path()
  {
    return (EAttribute)declarationEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EClass getFixedDeclaration()
  {
    return fixedDeclarationEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EAttribute getFixedDeclaration_Kind()
  {
    return (EAttribute)fixedDeclarationEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EAttribute getFixedDeclaration_Path()
  {
    return (EAttribute)fixedDeclarationEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EClass getRule()
  {
    return ruleEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EAttribute getRule_Name()
  {
    return (EAttribute)ruleEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EAttribute getRule_Kind()
  {
    return (EAttribute)ruleEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EReference getRule_Decls()
  {
    return (EReference)ruleEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EAttribute getRule_CompOp()
  {
    return (EAttribute)ruleEClass.getEStructuralFeatures().get(3);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EAttribute getRule_CompValue()
  {
    return (EAttribute)ruleEClass.getEStructuralFeatures().get(4);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EClass getCase()
  {
    return caseEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EAttribute getCase_Kind()
  {
    return (EAttribute)caseEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EReference getCase_Condition()
  {
    return (EReference)caseEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EReference getCase_Properties()
  {
    return (EReference)caseEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EClass getExpr()
  {
    return exprEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EClass getGroupExpr()
  {
    return groupExprEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EAttribute getGroupExpr_HasNot()
  {
    return (EAttribute)groupExprEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EReference getGroupExpr_Expr()
  {
    return (EReference)groupExprEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EAttribute getGroupExpr_Card()
  {
    return (EAttribute)groupExprEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EClass getProperty()
  {
    return propertyEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EAttribute getProperty_Frequency()
  {
    return (EAttribute)propertyEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EReference getProperty_Criterion()
  {
    return (EReference)propertyEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EClass getOr()
  {
    return orEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EReference getOr_Left()
  {
    return (EReference)orEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EReference getOr_Right()
  {
    return (EReference)orEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EClass getAnd()
  {
    return andEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EReference getAnd_Left()
  {
    return (EReference)andEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EAttribute getAnd_ConcatKind()
  {
    return (EAttribute)andEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EReference getAnd_Right()
  {
    return (EReference)andEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EClass getStringConst()
  {
    return stringConstEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EAttribute getStringConst_HasNot()
  {
    return (EAttribute)stringConstEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EAttribute getStringConst_Value()
  {
    return (EAttribute)stringConstEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EAttribute getStringConst_Card()
  {
    return (EAttribute)stringConstEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EAttribute getStringConst_Sentiment()
  {
    return (EAttribute)stringConstEClass.getEStructuralFeatures().get(3);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EClass getPOSValue()
  {
    return posValueEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EAttribute getPOSValue_HasNot()
  {
    return (EAttribute)posValueEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EAttribute getPOSValue_Pos()
  {
    return (EAttribute)posValueEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EAttribute getPOSValue_Card()
  {
    return (EAttribute)posValueEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EAttribute getPOSValue_Sentiment()
  {
    return (EAttribute)posValueEClass.getEStructuralFeatures().get(3);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EClass getSynonymConst()
  {
    return synonymConstEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EAttribute getSynonymConst_HasNot()
  {
    return (EAttribute)synonymConstEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EAttribute getSynonymConst_Value()
  {
    return (EAttribute)synonymConstEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EAttribute getSynonymConst_Card()
  {
    return (EAttribute)synonymConstEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EAttribute getSynonymConst_Sentiment()
  {
    return (EAttribute)synonymConstEClass.getEStructuralFeatures().get(3);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EEnum getKind()
  {
    return kindEEnum;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EEnum getSentiment()
  {
    return sentimentEEnum;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EEnum getPOS()
  {
    return posEEnum;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EEnum getCardinalityModifier()
  {
    return cardinalityModifierEEnum;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EEnum getFrequency()
  {
    return frequencyEEnum;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public MethodNameFactory getMethodNameFactory()
  {
    return (MethodNameFactory)getEFactoryInstance();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private boolean isCreated = false;

  /**
   * Creates the meta-model objects for the package.  This method is
   * guarded to have no affect on any invocation but its first.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void createPackageContents()
  {
    if (isCreated) return;
    isCreated = true;

    // Create classes and their features
    modelEClass = createEClass(MODEL);
    createEReference(modelEClass, MODEL__DECLARATIONS);
    createEReference(modelEClass, MODEL__FIXED_DECLARATIONS);
    createEReference(modelEClass, MODEL__RULES);
    createEReference(modelEClass, MODEL__ELEMENTS);

    declarationEClass = createEClass(DECLARATION);
    createEAttribute(declarationEClass, DECLARATION__NAME);
    createEAttribute(declarationEClass, DECLARATION__PATH);

    fixedDeclarationEClass = createEClass(FIXED_DECLARATION);
    createEAttribute(fixedDeclarationEClass, FIXED_DECLARATION__KIND);
    createEAttribute(fixedDeclarationEClass, FIXED_DECLARATION__PATH);

    ruleEClass = createEClass(RULE);
    createEAttribute(ruleEClass, RULE__NAME);
    createEAttribute(ruleEClass, RULE__KIND);
    createEReference(ruleEClass, RULE__DECLS);
    createEAttribute(ruleEClass, RULE__COMP_OP);
    createEAttribute(ruleEClass, RULE__COMP_VALUE);

    caseEClass = createEClass(CASE);
    createEAttribute(caseEClass, CASE__KIND);
    createEReference(caseEClass, CASE__CONDITION);
    createEReference(caseEClass, CASE__PROPERTIES);

    exprEClass = createEClass(EXPR);

    groupExprEClass = createEClass(GROUP_EXPR);
    createEAttribute(groupExprEClass, GROUP_EXPR__HAS_NOT);
    createEReference(groupExprEClass, GROUP_EXPR__EXPR);
    createEAttribute(groupExprEClass, GROUP_EXPR__CARD);

    propertyEClass = createEClass(PROPERTY);
    createEAttribute(propertyEClass, PROPERTY__FREQUENCY);
    createEReference(propertyEClass, PROPERTY__CRITERION);

    orEClass = createEClass(OR);
    createEReference(orEClass, OR__LEFT);
    createEReference(orEClass, OR__RIGHT);

    andEClass = createEClass(AND);
    createEReference(andEClass, AND__LEFT);
    createEAttribute(andEClass, AND__CONCAT_KIND);
    createEReference(andEClass, AND__RIGHT);

    stringConstEClass = createEClass(STRING_CONST);
    createEAttribute(stringConstEClass, STRING_CONST__HAS_NOT);
    createEAttribute(stringConstEClass, STRING_CONST__VALUE);
    createEAttribute(stringConstEClass, STRING_CONST__CARD);
    createEAttribute(stringConstEClass, STRING_CONST__SENTIMENT);

    posValueEClass = createEClass(POS_VALUE);
    createEAttribute(posValueEClass, POS_VALUE__HAS_NOT);
    createEAttribute(posValueEClass, POS_VALUE__POS);
    createEAttribute(posValueEClass, POS_VALUE__CARD);
    createEAttribute(posValueEClass, POS_VALUE__SENTIMENT);

    synonymConstEClass = createEClass(SYNONYM_CONST);
    createEAttribute(synonymConstEClass, SYNONYM_CONST__HAS_NOT);
    createEAttribute(synonymConstEClass, SYNONYM_CONST__VALUE);
    createEAttribute(synonymConstEClass, SYNONYM_CONST__CARD);
    createEAttribute(synonymConstEClass, SYNONYM_CONST__SENTIMENT);

    // Create enums
    kindEEnum = createEEnum(KIND);
    sentimentEEnum = createEEnum(SENTIMENT);
    posEEnum = createEEnum(POS);
    cardinalityModifierEEnum = createEEnum(CARDINALITY_MODIFIER);
    frequencyEEnum = createEEnum(FREQUENCY);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private boolean isInitialized = false;

  /**
   * Complete the initialization of the package and its meta-model.  This
   * method is guarded to have no affect on any invocation but its first.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void initializePackageContents()
  {
    if (isInitialized) return;
    isInitialized = true;

    // Initialize package
    setName(eNAME);
    setNsPrefix(eNS_PREFIX);
    setNsURI(eNS_URI);

    // Create type parameters

    // Set bounds for type parameters

    // Add supertypes to classes
    groupExprEClass.getESuperTypes().add(this.getExpr());
    orEClass.getESuperTypes().add(this.getExpr());
    andEClass.getESuperTypes().add(this.getExpr());
    stringConstEClass.getESuperTypes().add(this.getExpr());
    posValueEClass.getESuperTypes().add(this.getExpr());
    synonymConstEClass.getESuperTypes().add(this.getExpr());

    // Initialize classes and features; add operations and parameters
    initEClass(modelEClass, Model.class, "Model", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getModel_Declarations(), this.getDeclaration(), null, "declarations", null, 0, -1, Model.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getModel_FixedDeclarations(), this.getFixedDeclaration(), null, "fixedDeclarations", null, 0, -1, Model.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getModel_Rules(), this.getRule(), null, "rules", null, 0, -1, Model.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getModel_Elements(), this.getCase(), null, "elements", null, 0, -1, Model.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(declarationEClass, Declaration.class, "Declaration", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getDeclaration_Name(), ecorePackage.getEString(), "name", null, 0, 1, Declaration.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getDeclaration_Path(), ecorePackage.getEString(), "path", null, 0, 1, Declaration.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(fixedDeclarationEClass, FixedDeclaration.class, "FixedDeclaration", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getFixedDeclaration_Kind(), this.getKind(), "kind", null, 0, 1, FixedDeclaration.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getFixedDeclaration_Path(), ecorePackage.getEString(), "path", null, 0, 1, FixedDeclaration.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(ruleEClass, Rule.class, "Rule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getRule_Name(), ecorePackage.getEString(), "name", null, 0, 1, Rule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getRule_Kind(), this.getKind(), "kind", null, 0, 1, Rule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getRule_Decls(), this.getDeclaration(), null, "decls", null, 0, -1, Rule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getRule_CompOp(), ecorePackage.getEString(), "compOp", null, 0, 1, Rule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getRule_CompValue(), ecorePackage.getEInt(), "compValue", null, 0, 1, Rule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(caseEClass, Case.class, "Case", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getCase_Kind(), this.getKind(), "kind", null, 0, 1, Case.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getCase_Condition(), this.getExpr(), null, "condition", null, 0, 1, Case.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getCase_Properties(), this.getProperty(), null, "properties", null, 0, -1, Case.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(exprEClass, Expr.class, "Expr", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

    initEClass(groupExprEClass, GroupExpr.class, "GroupExpr", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getGroupExpr_HasNot(), ecorePackage.getEBoolean(), "hasNot", null, 0, 1, GroupExpr.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getGroupExpr_Expr(), this.getExpr(), null, "expr", null, 0, 1, GroupExpr.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getGroupExpr_Card(), this.getCardinalityModifier(), "card", null, 0, 1, GroupExpr.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(propertyEClass, Property.class, "Property", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getProperty_Frequency(), this.getFrequency(), "frequency", null, 0, 1, Property.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getProperty_Criterion(), this.getRule(), null, "criterion", null, 0, 1, Property.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(orEClass, Or.class, "Or", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getOr_Left(), this.getExpr(), null, "left", null, 0, 1, Or.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getOr_Right(), this.getExpr(), null, "right", null, 0, 1, Or.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(andEClass, And.class, "And", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getAnd_Left(), this.getExpr(), null, "left", null, 0, 1, And.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getAnd_ConcatKind(), ecorePackage.getEString(), "concatKind", null, 0, 1, And.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getAnd_Right(), this.getExpr(), null, "right", null, 0, 1, And.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(stringConstEClass, StringConst.class, "StringConst", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getStringConst_HasNot(), ecorePackage.getEBoolean(), "hasNot", null, 0, 1, StringConst.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getStringConst_Value(), ecorePackage.getEString(), "value", null, 0, 1, StringConst.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getStringConst_Card(), this.getCardinalityModifier(), "card", null, 0, 1, StringConst.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getStringConst_Sentiment(), this.getSentiment(), "sentiment", null, 0, 1, StringConst.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(posValueEClass, POSValue.class, "POSValue", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getPOSValue_HasNot(), ecorePackage.getEBoolean(), "hasNot", null, 0, 1, POSValue.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getPOSValue_Pos(), this.getPOS(), "pos", null, 0, 1, POSValue.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getPOSValue_Card(), this.getCardinalityModifier(), "card", null, 0, 1, POSValue.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getPOSValue_Sentiment(), this.getSentiment(), "sentiment", null, 0, 1, POSValue.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(synonymConstEClass, SynonymConst.class, "SynonymConst", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getSynonymConst_HasNot(), ecorePackage.getEBoolean(), "hasNot", null, 0, 1, SynonymConst.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getSynonymConst_Value(), ecorePackage.getEString(), "value", null, 0, 1, SynonymConst.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getSynonymConst_Card(), this.getCardinalityModifier(), "card", null, 0, 1, SynonymConst.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getSynonymConst_Sentiment(), this.getSentiment(), "sentiment", null, 0, 1, SynonymConst.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    // Initialize enums and add enum literals
    initEEnum(kindEEnum, Kind.class, "Kind");
    addEEnumLiteral(kindEEnum, Kind.KIND_INTERFACE);
    addEEnumLiteral(kindEEnum, Kind.KIND_PACKAGE);
    addEEnumLiteral(kindEEnum, Kind.KIND_CLASS);
    addEEnumLiteral(kindEEnum, Kind.KIND_METHOD);
    addEEnumLiteral(kindEEnum, Kind.KIND_VAR);

    initEEnum(sentimentEEnum, Sentiment.class, "Sentiment");
    addEEnumLiteral(sentimentEEnum, Sentiment.SENT_UNSPECIFIED);
    addEEnumLiteral(sentimentEEnum, Sentiment.SENT_NEUTRAL);
    addEEnumLiteral(sentimentEEnum, Sentiment.SENT_POSITIVE);
    addEEnumLiteral(sentimentEEnum, Sentiment.SENT_NEGATIVE);

    initEEnum(posEEnum, org.xtext.example.methodname.methodName.POS.class, "POS");
    addEEnumLiteral(posEEnum, org.xtext.example.methodname.methodName.POS.POS_CC);
    addEEnumLiteral(posEEnum, org.xtext.example.methodname.methodName.POS.POS_CD);
    addEEnumLiteral(posEEnum, org.xtext.example.methodname.methodName.POS.POS_DT);
    addEEnumLiteral(posEEnum, org.xtext.example.methodname.methodName.POS.POS_EX);
    addEEnumLiteral(posEEnum, org.xtext.example.methodname.methodName.POS.POS_FW);
    addEEnumLiteral(posEEnum, org.xtext.example.methodname.methodName.POS.POS_IN);
    addEEnumLiteral(posEEnum, org.xtext.example.methodname.methodName.POS.POS_JJ);
    addEEnumLiteral(posEEnum, org.xtext.example.methodname.methodName.POS.POS_JJR);
    addEEnumLiteral(posEEnum, org.xtext.example.methodname.methodName.POS.POS_JJS);
    addEEnumLiteral(posEEnum, org.xtext.example.methodname.methodName.POS.POS_LS);
    addEEnumLiteral(posEEnum, org.xtext.example.methodname.methodName.POS.POS_MD);
    addEEnumLiteral(posEEnum, org.xtext.example.methodname.methodName.POS.POS_NN);
    addEEnumLiteral(posEEnum, org.xtext.example.methodname.methodName.POS.POS_NNS);
    addEEnumLiteral(posEEnum, org.xtext.example.methodname.methodName.POS.POS_NNP);
    addEEnumLiteral(posEEnum, org.xtext.example.methodname.methodName.POS.POS_NNPS);
    addEEnumLiteral(posEEnum, org.xtext.example.methodname.methodName.POS.POS_PDT);
    addEEnumLiteral(posEEnum, org.xtext.example.methodname.methodName.POS.POS_POS);
    addEEnumLiteral(posEEnum, org.xtext.example.methodname.methodName.POS.POS_PRP);
    addEEnumLiteral(posEEnum, org.xtext.example.methodname.methodName.POS.POS_RB);
    addEEnumLiteral(posEEnum, org.xtext.example.methodname.methodName.POS.POS_RBR);
    addEEnumLiteral(posEEnum, org.xtext.example.methodname.methodName.POS.POS_RBS);
    addEEnumLiteral(posEEnum, org.xtext.example.methodname.methodName.POS.POS_RP);
    addEEnumLiteral(posEEnum, org.xtext.example.methodname.methodName.POS.POS_SYM);
    addEEnumLiteral(posEEnum, org.xtext.example.methodname.methodName.POS.POS_TO);
    addEEnumLiteral(posEEnum, org.xtext.example.methodname.methodName.POS.POS_UH);
    addEEnumLiteral(posEEnum, org.xtext.example.methodname.methodName.POS.POS_VB);
    addEEnumLiteral(posEEnum, org.xtext.example.methodname.methodName.POS.POS_VBD);
    addEEnumLiteral(posEEnum, org.xtext.example.methodname.methodName.POS.POS_VBG);
    addEEnumLiteral(posEEnum, org.xtext.example.methodname.methodName.POS.POS_VBN);
    addEEnumLiteral(posEEnum, org.xtext.example.methodname.methodName.POS.POS_VBP);
    addEEnumLiteral(posEEnum, org.xtext.example.methodname.methodName.POS.POS_VBZ);
    addEEnumLiteral(posEEnum, org.xtext.example.methodname.methodName.POS.POS_WDT);
    addEEnumLiteral(posEEnum, org.xtext.example.methodname.methodName.POS.POS_WP);
    addEEnumLiteral(posEEnum, org.xtext.example.methodname.methodName.POS.POS_WRB);

    initEEnum(cardinalityModifierEEnum, CardinalityModifier.class, "CardinalityModifier");
    addEEnumLiteral(cardinalityModifierEEnum, CardinalityModifier.CARD_1);
    addEEnumLiteral(cardinalityModifierEEnum, CardinalityModifier.CARD_0N);
    addEEnumLiteral(cardinalityModifierEEnum, CardinalityModifier.CARD_1N);
    addEEnumLiteral(cardinalityModifierEEnum, CardinalityModifier.CARD_01);

    initEEnum(frequencyEEnum, Frequency.class, "Frequency");
    addEEnumLiteral(frequencyEEnum, Frequency.ALWAYS);
    addEEnumLiteral(frequencyEEnum, Frequency.VERYOFTEN);
    addEEnumLiteral(frequencyEEnum, Frequency.OFTE);
    addEEnumLiteral(frequencyEEnum, Frequency.RARELY);
    addEEnumLiteral(frequencyEEnum, Frequency.VERYSELDOM);
    addEEnumLiteral(frequencyEEnum, Frequency.NEVER);

    // Create resource
    createResource(eNS_URI);
  }

} //MethodNamePackageImpl
